/*

  MacTCP classes
 
 	Copyright  NCSA, University of Illinois;	June 2, 1992
  Eric Johnson, John Newlin and Igor Livshits
  
  This code may be used, modified, and distributed free of charge and obligation.
  
*/
/*

John's revisions
================

1. Changed CTCPClient::GetLocalAddress() to have only one return.  (6/10/92 isl)
2. Changed CTCPDriver::IMacTCPDriver() to avoid moving memory error.  (6/10/92 isl)
3. Changed CTCP::SetDestination() to avoid errors caused by SegLoader moving memory.  (6/10/92 isl)
4. Changed CTCP::GetDestination() for same reason as above.  (6/10/92 isl)
5. Changed CTCPClient::ITCPClient() to avoid moving memory error.  (6/10/92 isl)
6. The parameter block is now disposed by the driver, not the stream.  (6/10/92 isl)
7. Changed CTCPDriver::Control() to ::SendControlInfoToDriver().  (6/10/92 isl)
8. Redundant FailNIL()'s removed.  (6/10/92 isl)
9. Revised handling of the parameter block -- SetSize__, Make__, Get__, Set__.  (6/10/92 isl)
10.Added CTCP::GetInputBuffer().  (6/15/92 isl)
11.Added CTCPClient::MyBufferReceiveData().  (6/15/92 isl)
12.Changed CTCPClient::MyBufferReceiveData() to not restore the original buffer 
                                             if it is null. (6/19/92 jn)
13.Added CTCPClient::ReleaseBuffer().  (6/19/92 jn)
14.Changed CTCP declaration to make GetTimeout and SetTimeout public so I could change
   the timeout value from the Client.

*/
/*

Igor's revisions
================

1. Fixed a silly pb incompatibility bug in CTCP::GetMyIPAddress().  (6/15/92 isl)
2. Rewrote CTCPClient::GetLocalAddress() return last error and take an argument.  (6/15/92 isl)
3. Added CTCPClient::GetLocalDotAddress().  (6/15/92 isl)
4. Incorporated John's vesion of CTCP::SetInputBuffer().  (6/15/92 isl)
5. Added CTCP::ReleaseInputBuffer().  (6/15/92 isl)
6. Added release methods for each of the stream and output buffers.  (6/16/92 isl)
7. Added a release method for all three buffers.  (6/16/92 isl)
8. Rewrote CTCP::SetInputBuffer() to only set to passed buffer (John's original).  (6/16/92 isl)
9. Wrote a CTCP::CreateBuffer() method just in case.  (6/16/92 isl)
10.Renamed __Data to __Buffer in CTCP for consistency.  (6/16/92 isl)


*/
/*

Bernie's revisions
================

1. Fixed a declaration error in CTCPClient::Kill().  (12/10/92 isl)
2. Fixed an ommitted dereference in CTCPClient::ReceiveData()/  (12/10/92 isl)


*/

